/*

 File: functions.h, 2004/06/18

 ACETAF, Version 3.0.1

 Copyright (C) Markus Neher, markus.neher@math.uni-karlsruhe.de
               Ingo Eble,    ingoeble@web.de

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _FUNCTIONS_H_INCLUDED
#define _FUNCTIONS_H_INCLUDED

#include "functions.tpl"

/*

Spezialisierungen der Template-Funktionen fuer verschiedene Parameter.

*/

// Parameter: CInterval
//
#include "cinterval.h"

template<> CInterval EXP   (const CInterval&);
template<> CInterval LN    (const CInterval&);
template<> CInterval SQR   (const CInterval&);
template<> CInterval SQRT  (const CInterval&);
template<> CInterval SIN   (const CInterval&);
template<> CInterval COS   (const CInterval&);
template<> CInterval TAN   (const CInterval&);
template<> CInterval COT   (const CInterval&);
template<> CInterval ASIN  (const CInterval&);
template<> CInterval ACOS  (const CInterval&);
template<> CInterval ATAN  (const CInterval&);
template<> CInterval ACOT  (const CInterval&);
template<> CInterval SINH  (const CInterval&);
template<> CInterval COSH  (const CInterval&);
template<> CInterval TANH  (const CInterval&);
template<> CInterval COTH  (const CInterval&);
template<> CInterval ASINH (const CInterval&);
template<> CInterval ACOSH (const CInterval&);
template<> CInterval ATANH (const CInterval&);
template<> CInterval ACOTH (const CInterval&);
template<> CInterval SQRT  (const CInterval&,int);
template<> CInterval POWER (const CInterval&,int);
template<> CInterval POW   (const CInterval&,const CInterval&);

// Parameter: Interval
//
#include "adaptintval.h"

template<> Interval EXP   (const Interval&);
template<> Interval LN    (const Interval&);
template<> Interval SQR   (const Interval&);
template<> Interval SQRT  (const Interval&);
template<> Interval SIN   (const Interval&);
template<> Interval COS   (const Interval&);
template<> Interval TAN   (const Interval&);
template<> Interval COT   (const Interval&);
template<> Interval ASIN  (const Interval&);
template<> Interval ACOS  (const Interval&);
template<> Interval ATAN  (const Interval&);
template<> Interval ACOT  (const Interval&);
template<> Interval SINH  (const Interval&);
template<> Interval COSH  (const Interval&);
template<> Interval TANH  (const Interval&);
template<> Interval COTH  (const Interval&);
template<> Interval ASINH (const Interval&);
template<> Interval ACOSH (const Interval&);
template<> Interval ATANH (const Interval&);
template<> Interval ACOTH (const Interval&);
template<> Interval SQRT  (const Interval&,int);
template<> Interval POWER (const Interval&,int);
template<> Interval POW   (const Interval&,const Interval&);

// Parameter: CITaylor
//
#include "taylor.h"

template<> CITaylor EXP   (const CITaylor&);
template<> CITaylor LN    (const CITaylor&);
template<> CITaylor SQR   (const CITaylor&);
template<> CITaylor SQRT  (const CITaylor&);
template<> CITaylor SIN   (const CITaylor&);
template<> CITaylor COS   (const CITaylor&);
template<> CITaylor TAN   (const CITaylor&);
template<> CITaylor COT   (const CITaylor&);
template<> CITaylor ASIN  (const CITaylor&);
template<> CITaylor ACOS  (const CITaylor&);
template<> CITaylor ATAN  (const CITaylor&);
template<> CITaylor ACOT  (const CITaylor&);
template<> CITaylor SINH  (const CITaylor&);
template<> CITaylor COSH  (const CITaylor&);
template<> CITaylor TANH  (const CITaylor&);
template<> CITaylor COTH  (const CITaylor&);
template<> CITaylor ASINH (const CITaylor&);
template<> CITaylor ACOSH (const CITaylor&);
template<> CITaylor ATANH (const CITaylor&);
template<> CITaylor ACOTH (const CITaylor&);
template<> CITaylor SQRT  (const CITaylor&,int);
template<> CITaylor POWER (const CITaylor&,int);
template<> CITaylor POW   (const CITaylor&,const CITaylor&);

#endif

/*

  End of File: functions.h

*/
